Index: pplinux/linuxnew/drivers/hotplug/dummyphp_core.c
diff -u /dev/null pplinux/linuxnew/drivers/hotplug/dummyphp_core.c:1.1
--- /dev/null	Tue May 24 10:37:58 2005
+++ pplinux/linuxnew/drivers/hotplug/dummyphp_core.c	Fri Apr 29 10:43:28 2005
@@ -0,0 +1,438 @@
+/*
+ * Dummy PCI Hot Plug Controller Driver
+ *
+ * Copyright (c) 2003 Rolf Eike Beer <eike-kernel@sf...>
+ *
+ * Based on code from:
+ *	Vladimir Kondratiev <vladimir.kondratiev@in...>
+ *	Greg Kroah-Hartman <greg@kr...>
+ *
+ * All rights reserved.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, version 2 of the License.
+ *
+ * Send feedback to <eike-kernel@sf...>
+ */
+
+/*
+ *
+ * This driver will "emulate" removing PCI devices from the system.  If
+ * the "power" file is written to with "0" then the specified PCI device
+ * will be completely removed from the kernel.
+ *
+ * WARNING, this does NOT turn off the power to the PCI device.  This is
+ * a "logical" removal, not a physical or electrical removal.
+ *
+ * Use this module at your own risk, you have been warned!
+ *
+ */
+#include <linux/config.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/pci.h>
+#include <linux/init.h>
+#include "pci_hotplug.h"
+
+#define dbg(format, arg...)					\
+	do {							\
+	    if (debug)						\
+			printk(KERN_DEBUG "%s: " format,	\
+				MY_NAME , ## arg); 		\
+	} while (0)
+#define err(format, arg...) printk(KERN_ERR "%s: " format, MY_NAME , ## arg)
+#define info(format, arg...) printk(KERN_INFO "%s: " format, MY_NAME , ## arg)
+
+/* name size which is used for entries in pcihpfs */
+#define SLOT_NAME_SIZE	16		/* DUMMY-{BUS}:{DEV} */
+
+struct dummy_slot {
+	struct list_head node;
+	struct pci_bus	*bus;
+	int		devfn;
+	struct pci_dev	*dev;
+	struct hotplug_slot *slot;
+};
+
+#ifndef CONFIG_HOTPLUG_PCI_DUMMY_MODULE
+	#define MY_NAME	"dummyphp"
+#else
+	#define MY_NAME	THIS_MODULE->name
+#endif
+
+static int debug;
+static LIST_HEAD(slot_list);
+
+#define DRIVER_VERSION	"0.1"
+#define DRIVER_AUTHOR	"Rolf Eike Beer <eike-kernel@sf...>"
+#define DRIVER_DESC	"Dummy Hot Plug PCI Controller Driver"
+
+MODULE_AUTHOR(DRIVER_AUTHOR);
+MODULE_DESCRIPTION(DRIVER_DESC);
+MODULE_LICENSE("GPL");
+MODULE_PARM(debug, "i");
+MODULE_PARM_DESC(debug, "Debugging mode enabled or not");
+
+static int enable_slot (struct hotplug_slot *slot);
+static int disable_slot (struct hotplug_slot *slot);
+static int configure_device(struct pci_bus* bus, struct pci_dev* dev);
+
+static struct hotplug_slot_ops dummy_hotplug_slot_ops = {
+	.owner			= THIS_MODULE,
+	.enable_slot		= enable_slot,
+	.disable_slot		= disable_slot,
+};
+
+static int
+configure_device(struct pci_bus* bus, struct pci_dev* dev)
+{
+    u8 irq_pin;
+    int r;
+
+    dbg("%s - enter\n", __FUNCTION__);
+
+    /* Assign resources */
+    dbg("assigning resources for %02x:%02x.%x\n",
+	dev->bus->number, PCI_SLOT(dev->devfn), PCI_FUNC(dev->devfn));
+    for (r = 0; r < 6; r++) {
+	struct resource *res = dev->resource + r;
+	if(res->flags)
+	    pci_assign_resource(dev, r);
+    }
+    dbg("finished assigning resources for %02x:%02x.%x\n",
+	dev->bus->number, PCI_SLOT(dev->devfn), PCI_FUNC(dev->devfn));
+    
+    /* Does this function have an interrupt at all? */
+    dbg("checking for function interrupt\n");
+    pci_read_config_byte(dev, PCI_INTERRUPT_PIN, &irq_pin);
+    if(irq_pin) {
+	dbg("function uses interrupt pin %d\n", irq_pin);
+    }
+    
+    /*
+     * Need to explicitly set irq field to 0 so that it'll get assigned
+     * by the pcibios platform dependent code called by pci_enable_device.
+     */
+    dev->irq = 0;
+    
+    dbg("enabling device\n");
+    pci_enable_device(dev);	/* XXX check return */
+    dbg("now dev->irq = %d\n", dev->irq);
+    if(irq_pin && dev->irq) {
+	pci_write_config_byte(dev, PCI_INTERRUPT_LINE, dev->irq);
+    }
+    
+    /* Can't use pci_insert_device at the moment, do it manually for now */
+    pci_proc_attach_device(dev);
+    dbg("notifying drivers\n");
+    pci_announce_device_to_drivers(dev);
+    dbg("%s - exit\n", __FUNCTION__);
+    return 0;       
+}
+
+/**
+ * configure_visit_pci_dev - callback to configure new discovered devices
+ * @wrapped_dev: the device
+ * @wrapped_bus: the bus of the device
+ */
+static int configure_visit_pci_dev (struct pci_dev_wrapped *wrapped_dev,
+				    struct pci_bus_wrapped *wrapped_bus)
+{
+	struct pci_dev* dev = wrapped_dev->dev;
+	struct pci_bus *bus = wrapped_bus->bus;
+	int ret = -1;	
+	
+	/* Create /proc/bus/pci proc entry for this device and bus device is on
+	   Notify the drivers of the change */
+	dbg("%s - starting\n", __FUNCTION__);
+	if (dev) {
+	    ret = configure_device(bus, dev);
+	    if (ret) goto bail;    
+	}
+
+	ret = 0;
+ bail:
+	return ret;
+}
+
+static struct pci_visit configure_functions = {
+	visit_pci_dev:		configure_visit_pci_dev,
+};
+
+/**
+ * enable_slot - power on and enable a slot
+ * @hotplug_slot: slot to enable
+ */
+static int
+enable_slot(struct hotplug_slot *hotplug_slot)
+{
+	struct pci_dev dev0;
+	struct dummy_slot *slot;
+	struct pci_bus *child;
+	unsigned char bus;
+	struct pci_dev_wrapped wrapped_dev;
+	struct pci_bus_wrapped wrapped_bus;
+	int rc = 0;
+
+	if (!hotplug_slot)
+		return -ENODEV;
+
+	dbg("%s - physical_slot = %s\n", __FUNCTION__, hotplug_slot->name);
+
+	/* enable the specified slot */
+	slot = (struct dummy_slot *) hotplug_slot->private;
+	slot->dev = pci_find_slot(slot->bus->number, slot->devfn);
+
+	/* Still NULL ? Well then scan for it ! */
+	if (slot->dev == NULL) {
+		dbg("INFO: pci_dev still null\n");
+		memset(&dev0, 0, sizeof(struct pci_dev));
+		dev0.bus = slot->bus;
+		dev0.devfn = slot->devfn;
+		dev0.sysdata = slot->bus->sysdata;
+
+		/* this will generate pci_dev structures for all functions,
+		   but we will only call this case when lookup fails */
+		slot->dev = pci_scan_slot(&dev0);
+		if (slot->dev == NULL) {
+			dbg("ERROR: pci_dev still null\n");
+			return -ENODEV;
+		}
+	}
+
+	if (slot->dev->hdr_type == PCI_HEADER_TYPE_BRIDGE) {
+		pci_read_config_byte(slot->dev, PCI_SECONDARY_BUS, &bus);
+		child = (struct pci_bus*) pci_add_new_bus(slot->dev->bus,
+						(slot->dev), bus);
+		pci_do_scan_bus(child);
+
+	}
+
+	if (slot->dev) {
+		memset(&wrapped_dev, 0, sizeof(struct pci_dev_wrapped));
+		memset(&wrapped_bus, 0, sizeof(struct pci_bus_wrapped));
+		wrapped_dev.dev = slot->dev;
+		wrapped_bus.bus = slot->dev->bus;
+		rc = pci_visit_dev(&configure_functions, &wrapped_dev,
+				   &wrapped_bus);
+	}
+	return rc;
+}
+
+/**
+ * is_pci_dev_in_use - check if a driver uses a pci device
+ * @dev: the device to check
+ */
+static int
+is_pci_dev_in_use(struct pci_dev* dev) 
+{
+	/* 
+	 * dev->driver will be set if the device is in use by a new-style 
+	 * driver -- otherwise, check the device"s regions to see if any
+	 * driver has claimed them
+	 */
+
+	int i, inuse = 0;
+
+	if (dev->driver)
+		return 1; /* assume driver feels responsible */
+
+	for (i = 0; !dev->driver && !inuse && (i < 6); i++) {
+		if (!pci_resource_start(dev, i))
+			continue;
+
+		if (pci_resource_flags(dev, i) & IORESOURCE_IO)
+			inuse = check_region(pci_resource_start(dev, i),
+					     pci_resource_len(dev, i));
+		else if (pci_resource_flags(dev, i) & IORESOURCE_MEM)
+			inuse = check_mem_region(pci_resource_start(dev, i),
+						 pci_resource_len(dev, i));
+	}
+
+	return inuse;
+
+}
+
+/**
+ * disable_slot - disable any adapter in this slot
+ * @hotplug_slot: slot to disable
+ */
+static int
+disable_slot(struct hotplug_slot *hotplug_slot)
+{
+	struct pci_dev* old_dev;
+	int func;
+	struct dummy_slot *slot;
+
+	if (!hotplug_slot)
+		return -ENODEV;
+
+	slot = (struct dummy_slot *) hotplug_slot->private;
+
+	dbg("%s - physical_slot = %s\n", __FUNCTION__, hotplug_slot->name);
+
+	if (slot->dev == NULL) {
+	    dbg("%s - no device here yet\n", __FUNCTION__);
+	    return -ENODEV;
+	}
+	
+	/* assume the driver feels responsible if dev->driver is set */
+	if (is_pci_dev_in_use(slot->dev)) {
+		if (slot->dev->driver) {
+			err("Can't disable slot %x:%x, driver %s still holds reference to it!",
+				slot->bus->number, PCI_SLOT(slot->devfn),
+				slot->dev->driver->name);
+		} else {
+			err("Can't disable slot %x:%x, a driver still holds reference to it!",
+				slot->bus->number, PCI_SLOT(slot->devfn));
+		}
+		return -EBUSY;
+	}
+
+	/* disable the specified slot */
+
+	for (func = 0; func < 8; func++) {
+		old_dev = pci_find_slot(slot->bus->number, slot->devfn+func);
+		if (old_dev) {
+			printk(KERN_INFO "Slot %s Removed <%s>\n",
+					old_dev->slot_name, old_dev->name);
+			pci_remove_device(old_dev);
+		}
+	}
+	hotplug_slot->info->power_status = 0;
+	slot->dev = NULL;
+
+	return 0;
+}
+
+/**
+ * scan_pci_bus - add an entry for every slot on this bus
+ * @bus: bus to scan
+ */
+static int __init
+scan_pci_bus(const struct pci_bus *bus)
+{
+	struct dummy_slot *dslot;
+	struct hotplug_slot *hp;
+	int retval = -ENOMEM;
+	unsigned int devfn;
+	struct pci_dev dev0;
+
+	dbg("%s scanning\n", __FUNCTION__);
+	memset(&dev0, 0, sizeof(dev0));
+	dev0.bus = (struct pci_bus*)bus;
+	dev0.sysdata = bus->sysdata;
+	for (devfn = 0; devfn < 0x100; devfn += 8) {
+		hp = kmalloc(sizeof(struct hotplug_slot), GFP_KERNEL);
+		if (!hp)
+			goto error;
+
+		memset(hp, 0, sizeof(struct hotplug_slot));
+
+		hp->info = kmalloc(sizeof(struct hotplug_slot_info),
+					GFP_KERNEL);
+		if (!hp->info)
+			goto error_info;
+
+		memset(hp->info, 0, sizeof(struct hotplug_slot_info));
+
+		hp->name = kmalloc(SLOT_NAME_SIZE, GFP_KERNEL);
+		if ( !hp->name )
+			goto error_name;
+
+		dslot = kmalloc(sizeof(struct dummy_slot), GFP_KERNEL);
+		if ( !dslot )
+			goto error_slot;
+
+		dslot->bus = (struct pci_bus *) bus;
+		dslot->devfn = devfn;
+		dslot->slot = hp;
+
+		hp->ops = &dummy_hotplug_slot_ops;
+		hp->private = (void *) dslot;
+
+		dslot->dev = pci_find_slot(dslot->bus->number, dslot->devfn);
+		hp->info->power_status = (dslot->dev != NULL);
+
+		hp->info->cur_bus_speed = PCI_SPEED_UNKNOWN;
+		hp->info->max_bus_speed = PCI_SPEED_UNKNOWN;
+
+		snprintf(hp->name, SLOT_NAME_SIZE, "DUMMY-%02x:%02x",
+			dslot->bus->number, PCI_SLOT(dslot->devfn));
+	        dbg("Registering %s\n", hp->name);
+
+		retval = pci_hp_register(hp);
+		if (retval) {
+			err("pci_hp_register failed with error %d\n", retval);
+			goto error_register;
+		}
+		list_add(&dslot->node, &slot_list);
+	}
+	return 0;
+
+error_register:
+	kfree(dslot);
+error_slot:
+	kfree(hp->name);
+error_name:
+	kfree(hp->info);
+error_info:
+	kfree(hp);
+error:
+	return retval;
+}
+
+/**
+ * scan_pci_buses - scan this bus and all child buses for slots
+ * @list: list of buses to scan
+ */
+static int __init
+pci_scan_buses(const struct list_head *list)
+{
+	int retval;
+	const struct list_head *l;
+
+	list_for_each(l,list) {
+	        const struct pci_bus *b = pci_bus_b(l);
+		retval = scan_pci_bus(b);
+		if (retval)
+			return retval;
+		retval = pci_scan_buses(&b->children);
+		if (retval)
+			return retval;
+	}
+	return 0;
+}
+
+static void __exit
+cleanup_slots (void)
+{
+	struct list_head *tmp;
+	struct list_head *next;
+	struct dummy_slot *dslot;
+
+	list_for_each_safe (tmp, next, &slot_list) {
+		dslot = list_entry (tmp, struct dummy_slot, node);
+		pci_hp_deregister(dslot->slot);
+	}
+}
+
+
+static int __init
+dummyphp_init(void)
+{
+	info(DRIVER_DESC " version: " DRIVER_VERSION "\n");
+
+	return pci_scan_buses(&pci_root_buses);
+}
+
+
+static void __exit
+dummyphp_exit(void)
+{
+	cleanup_slots();
+}
+
+module_init(dummyphp_init);
+module_exit(dummyphp_exit);
Index: pplinux/linuxnew/drivers/i2c/Config.in
diff -u pplinux/linuxnew/drivers/i2c/Config.in:1.1.323.1 pplinux/linuxnew/drivers/i2c/Config.in:1.3
--- pplinux/linuxnew/drivers/i2c/Config.in:1.1.323.1	Thu Feb  3 10:00:38 2005
+++ pplinux/linuxnew/drivers/i2c/Config.in	Tue Feb 15 12:19:53 2005
@@ -7,6 +7,8 @@
 tristate 'I2C support' CONFIG_I2C
 
 if [ "$CONFIG_I2C" != "n" ]; then
+   dep_tristate 'I2C Slave Mode implementation' CONFIG_I2C_SLAVE $CONFIG_I2C
+
    dep_tristate 'I2C bit-banging interfaces'  CONFIG_I2C_ALGOBIT $CONFIG_I2C
    if [ "$CONFIG_I2C_ALGOBIT" != "n" ]; then
       dep_tristate '  Philips style parallel port adapter' CONFIG_I2C_PHILIPSPAR $CONFIG_I2C_ALGOBIT $CONFIG_PARPORT
@@ -38,14 +40,8 @@
          dep_tristate '  Embedded Planet RPX Lite/Classic support' CONFIG_I2C_RPXLITE $CONFIG_I2C_ALGO8XX
       fi
    fi
-   if [ "$CONFIG_405" = "y" ]; then
-      dep_tristate 'PPC 405 I2C Algorithm' CONFIG_I2C_PPC405_ALGO $CONFIG_I2C
-      if [ "$CONFIG_I2C_PPC405_ALGO" != "n" ]; then
-         dep_tristate '  PPC 405 I2C Adapter' CONFIG_I2C_PPC405_ADAP $CONFIG_I2C_PPC405_ALGO
-      fi
-      if [ "$CONFIG_XILINX_OCP" = "y" ]; then
-         dep_tristate 'Xilinx on-chip I2C' CONFIG_I2C_XILINX $CONFIG_I2C
-      fi
+   if [ "$CONFIG_IBM_OCP" = "y" ]; then
+      dep_tristate 'IBM IIC I2C interface' CONFIG_I2C_IBM_IIC $CONFIG_I2C
    fi
 
    if [ "$CONFIG_ALL_PPC" = "y" ] ; then
@@ -60,7 +56,9 @@
    if [ "$CONFIG_SGI_IP22" = "y" ]; then
       dep_tristate 'I2C SGI interfaces' CONFIG_I2C_ALGO_SGI $CONFIG_I2C
    fi
- 
+
+   dep_tristate "Asics I2C Master/Slave Adapter" CONFIG_I2C_ASICSMS $CONFIG_I2C
+    
 # This is needed for automatic patch generation: sensors code starts here
 # This is needed for automatic patch generation: sensors code ends here
 
Index: pplinux/linuxnew/drivers/i2c/Makefile
diff -u pplinux/linuxnew/drivers/i2c/Makefile:1.1.323.1 pplinux/linuxnew/drivers/i2c/Makefile:1.3
--- pplinux/linuxnew/drivers/i2c/Makefile:1.1.323.1	Thu Feb  3 10:00:39 2005
+++ pplinux/linuxnew/drivers/i2c/Makefile	Tue Feb 15 12:19:53 2005
@@ -6,10 +6,12 @@
 
 export-objs	:= i2c-core.o i2c-algo-bit.o i2c-algo-pcf.o \
 		   i2c-algo-ite.o i2c-algo-sibyte.o i2c-algo-sgi.o \
-		   i2c-proc.o i2c-ibm_iic.o i2c-algo-8xx.o
+		   i2c-proc.o i2c-ibm_iic.o i2c-algo-8xx.o \
+		   i2c-slave.o i2c-algo-asics.o
 mod-subdirs     := xilinx_iic
 
 obj-$(CONFIG_I2C)		+= i2c-core.o
+obj-$(CONFIG_I2C_SLAVE)		+= i2c-slave.o
 obj-$(CONFIG_I2C_CHARDEV)	+= i2c-dev.o
 obj-$(CONFIG_I2C_ALGOBIT)	+= i2c-algo-bit.o
 obj-$(CONFIG_I2C_PHILIPSPAR)	+= i2c-philips-par.o
@@ -24,6 +26,7 @@
 obj-$(CONFIG_SCx200_ACB)	+= scx200_acb.o
 obj-$(CONFIG_I2C_KEYWEST)	+= i2c-keywest.o
 obj-$(CONFIG_I2C_ALGO_SIBYTE)	+= i2c-algo-sibyte.o i2c-sibyte.o
+obj-$(CONFIG_I2C_ASICSMS)	+= i2c-algo-asics.o i2c-asics.o
 obj-$(CONFIG_I2C_MAX1617)	+= i2c-max1617.o
 obj-$(CONFIG_I2C_ALGO_SGI)	+= i2c-algo-sgi.o
 obj-$(CONFIG_I2C_ALGO8XX)	+= i2c-algo-8xx.o i2c-rpx.o
@@ -31,6 +34,7 @@
 subdir-$(CONFIG_I2C_XILINX)	+= xilinx_iic
 obj-$(CONFIG_I2C_XILINX)	+= xilinx_iic/xilinx_iic.o
 
+
 # This is needed for automatic patch generation: sensors code starts here
 # This is needed for automatic patch generation: sensors code ends here
 
